

(function () {

	function newLine(n) {
		var sel = zk(n).getSelectionRange();	
		if (sel[0] > sel[1]) {
			var t = sel[1];
			sel[1] = sel[0];
			sel[0] = t;
		}
		var str = n.value,
			len = str.length,
			str1 = str.substring(0, sel[0]); 
		str = str1 +'\n'+ str.substring(sel[1], len);
		n.value = str;
		
		var pos = sel[0];
		if (n.setSelectionRange) { 
			pos = zk.opera ? pos + 2 : pos + 1;
			n.setSelectionRange(pos, pos);
		} else if (n.createTextRange) {
			var range = n.createTextRange(),
				i = -1;
			pos = pos + 1;
			while((i = str1.indexOf('\n',i+1)) >= 0) {
				pos--;
			}
			range.move('character', pos);
			range.select();
		}
	}
	
	function syncEditorHeight(n) {
		var ch = n.clientHeight,
			cw = n.clientWidth,
			sw = n.scrollWidth,
			sh = n.scrollHeight,
			hsb = zkS._hasScrollBar(n),
			vsb = zkS._hasScrollBar(n, true);
		
		if (sh > ch + 3) {
			if (hsb && !vsb)
				jq(n).css('height', jq.px0(sh + zss.Spreadsheet.scrollWidth));
			else
				jq(n).css('height', jq.px0(sh));
		}
	}

	
	function getCellRefs(src) {
		return src.match('\\$?([A-Za-z]+)\\$?([0-9]+)');
	}
	
	
	function getEditingFormulaInfo(type, n, p) {
		var p = p || zk(n).getSelectionRange(),
			tp = type || 'inlineEditing',
			start = p[0],
			end = p[1],
			v = n.value,
			firstChar = v.charAt(0);
		if (firstChar && firstChar == '=') {
			if (start != end) { 
				return {start: start, end: end, type: tp};
			} else {
				if (!start) {
					return {start: 0, end: 0, type: tp};
				} else {
					var DELIMITERS = ['=', '+', '-', '*', '/', '!', ':', '^', '&', '(',  ',', '.'],
						i = start - 1,
						c = v.charAt(i);
					if (DELIMITERS.$contains(c)) {
						return {start: start, end: start, type: tp};
					}
				}
			}
		}
	}
	
	
	function insertCellRef(sheet, n, tRow, lCol, bRow, rCol) {
   		var info = sheet.editingFormulaInfo,
			start = info.start,
			end = info.end,
			v = n.value,
			c1 = sheet.getCell(tRow, lCol),
			c2 = tRow == bRow && lCol == rCol ? null : sheet.getCell(bRow, rCol),
			ref = c1.ref;
		if (c2) {
			ref += (':' + c2.ref);
		}
		if (!start) {
			ref = '=' + ref; 
		}
		n.value = v.substring(0, start) + ref + v.substring(end, v.length);
		sheet.inlineEditor.setValue(n.value);
		end = start + ref.length;
		info.end = end;
		if (zk.ie && zk.ie < 11) { 
			setTimeout(function () {
				zk(n).setSelectionRange(end, end);
			});
		} else {
			zk(n).setSelectionRange(end, end);
		}
	}

zss.FormulabarEditor = zk.$extends(zul.inp.InputWidget, {
	widgetName: 'FormulabarEditor',
	row: -1,
	col: -1,
   	$init: function (wgt) {
   		this.$supers(zss.FormulabarEditor, '$init', []);
   		this._wgt = wgt;
   	},
   	bind_: function () {
   		this.$supers(zss.FormulabarEditor, 'bind_', arguments);
   		var sheet = this._wgt.sheetCtrl;
   		if (sheet) {
   			this.sheet = sheet;
   			sheet.formulabarEditor = this;
   			
   			sheet.listen({'onStartEditing': this.proxy(this._onStartEditing)})
   				.listen({'onStopEditing': this.proxy(this.stop)})
   				.listen({'onCellSelection': this.proxy(this._onCellSelection)})
   				.listen({'onContentsChanged': this.proxy(this._onContentsChanged)});
   		}
   	},
   	unbind_: function () {
   		var sheet = this.sheet;
   		if (sheet) {
   			
   			sheet.unlisten({'onStartEditing': this.proxy(this._onStartEditing)})
   				.unlisten({'onStopEditing': this.proxy(this.stop)})
   				.unlisten({'onCellSelection': this.proxy(this._onCellSelection)})
   				.unlisten({'onContentsChanged': this.proxy(this._onContentsChanged)});
   			
   			sheet.formulaEditor = null;
   		}
   		this.sheet = this._wgt = null;
   		this.$supers(zss.FormulabarEditor, 'unbind_', arguments);
   	},
   	disable: zk.$void,
   	cancel: function () {
   		var sheet = this.sheet;
   		if (sheet) {
   			sheet.inlineEditor.cancel();
   		}
   		this.row = this.col = -1;
   	},
   	stop: function () {
	   	var sheet = this.sheet;
	   	if (sheet) {
	   		sheet.inlineEditor.stop();
   		}
   		this.row = this.col = -1;
   	},
   	
   	syncEditorPosition: function (p) {
		var	sheet = this.sheet;
		if (!sheet) {
			return;
		}
		
		var n = this.$n(); 
		var textarea = this.$n('real');

		
		
		p = p != undefined ? p : zk(textarea).getSelectionRange()[1];
		if (p <= 0) { 
			jq(n).scrollTop(0); 
			return;
		}
		
		
		var textHeight = this.getTextHeight(textarea.value.substring(0, p));
		var sp = textHeight - this.getLineHeight();
		jq(n).scrollTop(sp);
   	},
   	
   	getLineHeight: function() {
   		
   		if(this._lineHeight == undefined) {
   			
   			this._lineHeight = this.getTextHeight('a');
   		}
   		return this._lineHeight;
   	},
   	
   	getTextHeight: function(text) {
		var support = this.$n('support');
		support.value = text;
		var height = support.scrollHeight;
		support.value = null; 
		return height;
   	},
   	
   	setValue: function (v, pos) {
   		var n = this.$n();
	   	var textarea = this.$n('real');
	   	textarea.value = v;
   		if (this.isRealVisible()) {
   			
   			
   			jq(textarea).css('height', jq.px0(n.clientHeight - 3  ));
   	   		syncEditorHeight(textarea);
   	   		
   	   		this.syncEditorPosition(pos != undefined ? pos : textarea.value.length);
   		}
   	},
   	getValue: function () {
   		return this.$n('real').value;
   	},
   	newLine: function () {
   		newLine(this.$n('real'));
   	},
   	
   	focus: function () {
   		var n = this.$n('real');
   		if (zk(n).isRealVisible(true))
   			n.focus();
   	},
   	doFocus_: function () {
   		var sheet = this.sheet;
   		if (sheet) {
   			var info = sheet.editingFormulaInfo;
   			if (info) {
   				if (!info.moveCell) {
   					sheet.editingFormulaInfo = getEditingFormulaInfo('formulabarEditing', this.$n('real'));
   				} else {
   					
   				}
   			} else {
   	   	   		var p = this.sheet.getLastFocus(),
				 	ls = sheet.selArea.lastRange;
				sheet.moveCellFocus(p.row, p.column);
				sheet.moveCellSelection(ls.left, ls.top, ls.right, ls.bottom, false, true);
   			}
   		}
   	},
   	doBlur_: function () {
	   	var sheet = this.sheet;
	   	if (sheet) {
	   		setTimeout(function () {
	   			if (!sheet._wgt.hasFocus()) {
	   				sheet.dp.stopEditing(sheet.innerClicking > 0 ? "refocus" : "lostfocus");
	   			}
	   		}, 300);
	   	}
   	},
   	_onContentsChanged: function (evt) {
   		var sheet = this.sheet;
   		if (sheet && this.isRealVisible()) {
   			var p = sheet.getLastFocus(),
   				c = sheet.getCell(p.row, p.column);
   			if (c) {
   				
   				
   				this.setValue(c.edit || '', 0);
   			}
   		}
   	},
   	_onStartEditing: function (evt) {
   		var d = evt.data;
   		this.row = d.row;
   		this.col = d.col;
   	},
   	_onCellSelection: function (evt) {
   		var sheet = this.sheet;
   		if (sheet) {
   			if (sheet.state == zss.SSheetCtrl.FOCUSED) {
   			   	var d = evt.data,
   			   		cell = sheet.getCell(d.top, d.left);
   			   	if (cell) {
   			   		
   			   		this.setValue(cell.edit || '', 0);
   			   	} else {
   			   	}
   			} else if (sheet.state == zss.SSheetCtrl.EDITING) {
   				var info = sheet.editingFormulaInfo;
   				if (info && 'formulabarEditing' == info.type && !sheet._skipInsertCellRef) {
   					var d = evt.data;
   					insertCellRef(sheet, this.$n('real'), d.top, d.left, d.bottom, d.right);
   				}
   			}
   		}
   	},
	doMouseDown_: function (evt) {
		var sheet = this.sheet;
		if (sheet) {
			if (sheet.state == zss.SSheetCtrl.FOCUSED) {
				var p = sheet.getLastFocus(),
					c = sheet.getCell(p.row, p.column);
				if (c && sheet.dp.startEditing(evt, c.edit, 'formulabarEditing')) {
					this.row = p.row;
					this.col = p.column;
				} else { 
					sheet.dp.gainFocus(true);
				}
			} else if (sheet.state == zss.SSheetCtrl.NOFOCUS) {
				var p = sheet.getLastFocus(),
					row = p.row,
					col = p.column;
				sheet.dp.moveFocus(row == -1 ? 0 : row, col == -1 ? 0 : col);
				evt.stop();
			} else if (sheet.state == zss.SSheetCtrl.EDITING) {
				var info = sheet.editingFormulaInfo;
				if (info && info.moveCell) {
					sheet.editingFormulaInfo = getEditingFormulaInfo('formulabarEditing', this.$n('real'));
				}
			}
		}
	},
	doKeyDown_: function (evt) {
		var sheet = this.sheet;
		if (sheet) {
			sheet._doKeydown(evt);
		}
	},
	afterKeyDown_: function (evt, simulated) {
	},
	doKeyUp_: function (evt) {
		var sheet = this.sheet,
			keycode = evt.keyCode;
		if (sheet && sheet.state == zss.SSheetCtrl.EDITING) {
			var n = this.$n('real'),
				p = zk(n).getSelectionRange(),
				end = p[1],
				v = n.value,
				info = sheet.editingFormulaInfo;
			syncEditorHeight(n); 
			this.syncEditorPosition(end);
			sheet.inlineEditor.setValue(v);
			this._wgt.fire('onEditboxEditing', {token: '', sheetId: sheet.serverSheetId, row:this.row, col:this.col,  clienttxt: n.value});
			
			if (!v) {
				sheet.editingFormulaInfo = null;
				return;
			}
			
			var tp = 'formulabarEditing';
			if (info) {
				info.type = tp;
				if (info.moveCell) {
					if (info.end != end) { 
						sheet.editingFormulaInfo = getEditingFormulaInfo(tp, n, p);
					} else {
						
					}
				} else {
					sheet.editingFormulaInfo = getEditingFormulaInfo(tp, n, p);
				}
			} else {
				sheet.editingFormulaInfo = getEditingFormulaInfo(tp, n, p);
			}
		}
	},
	doKeyPress_: function (evt) {
	},
   	setWidth: function (v) {
   		this.$supers(zss.FormulabarEditor, 'setWidth', arguments);
   		
   		
   		
   		
   		var w = this.$n().clientWidth - 6; 
   		w = w - zss.Spreadsheet.scrollWidth; 
   		if(w < 0) {
   			w = 0;
   		}
   		jq(this.$n('real')).css('width', jq.px(w));
   		jq(this.$n('support')).css('width', jq.px(w)); 
   	},
   	setHeight: function (v) {
   		this.$supers(zss.FormulabarEditor, 'setHeight', arguments);
   		
   		
   		var textarea = this.$n('real');
   		var n = this.$n();
		jq(textarea).css('height', jq.px0(n.clientHeight - 3  )); 
   		syncEditorHeight(textarea);
   		this.syncEditorPosition();
   	},
   	redrawHTML_: function () {
   		var uid = this.uuid,
   			zcls = this.getZclass();
   		
   		return '<div id="' + uid + '" class="' + zcls + '"><textarea id="' + uid + '-real" class="' + zcls + '-real">' + this._areaText() + '</textarea><div id="' + uid + '-wrap-support" class="' + zcls + '-wrap-support"><textarea id="' + uid + '-support" class="' + zcls + '-support"></textarea></div></div>';
   	},
   	getZclass: function () {
   		return 'zsformulabar-editor';
   	}
});


zss.Editbox = zk.$extends(zul.inp.InputWidget, {
	widgetName: 'InlineEditor',
	_editing: false,
	_type: 'inlineEditing',
	$init: function (sheet) {
		this.$supers(zss.Editbox, '$init', []);
		var wgt = this._wgt = sheet._wgt;
		
		this.sheet = sheet;
		this.row = -1;
		this.col = -1;
		this.disabled = true;
	},
	bind_: function () {
		this.$supers(zss.Editbox, 'bind_', arguments);
		this.comp = this.$n();
		this.comp.ctrl = this;
		
		this.sheet.listen({'onStartEditing': this.proxy(this._onStartEditing)})
   			.listen({'onStopEditing': this.proxy(this.stop)})
   			.listen({'onCellSelection': this.proxy(this._onCellSelection)});
	},
	unbind_: function () {
		this.sheet.unlisten({'onStartEditing': this.proxy(this._onStartEditing)})
   			.unlisten({'onStopEditing': this.proxy(this.stop)})
   			.unlisten({'onCellSelection': this.proxy(this._onCellSelection)});
		
		this.sheet = this.comp.ctrl = this.comp = this._wgt = null;
		this.$supers(zss.Editbox, 'unbind_', arguments);
	},
	focus: function () {
		var n = this.comp;
   		if (zk(n).isRealVisible(true))
   			n.focus();
	},
	isEditing: function () {
		return this._editing;
	},
   	_onStartEditing: function (evt) {
   		var d = evt.data;
   		this.row = d.row;
   		this.col = d.col;
   	},
	_onCellSelection: function (evt) {
   		var sheet = this.sheet;
   		if (sheet) {
   			if (sheet.state == zss.SSheetCtrl.EDITING) {
   				var info = sheet.editingFormulaInfo;
   				if (info && 'inlineEditing' == info.type && !sheet._skipInsertCellRef) {
   					var d = evt.data,
   						formulabarEditor = sheet.formulabarEditor;
   					insertCellRef(sheet, this.comp, d.top, d.left, d.bottom, d.right);
   					if (formulabarEditor) {
   						var n = this.comp,
   							v = n.value;
   						formulabarEditor.setValue(v);
   					}
   				}
   			}
   		}
	},
	doFocus_: function () {
		this._editing = true;
	},
	doBlur_: function () {
	   	var sheet = this.sheet;
	   	if (sheet) {
	   		setTimeout(function () {
	   			if (!sheet._wgt.hasFocus()) {
	   				sheet.dp.stopEditing(sheet.innerClicking > 0 ? "refocus" : "lostfocus");
	   			}
	   		}, 300);
	   	}
	},
	doMouseDown_: function (evt) {
		var sheet = this.sheet;
		if (sheet) {
			if (sheet.state == zss.SSheetCtrl.EDITING) {
				var info = sheet.editingFormulaInfo;
				if (info && info.moveCell) {
					sheet.editingFormulaInfo = getEditingFormulaInfo(this._type, this.$n());
				}
			}
		}
	},
	doKeyPress_: function (evt) {
		this.autoAdjust(true);
	},
	doKeyDown_: function (evt) {
		if (this.disabled)
			evt.stop();
		else {
			this.sheet._doKeydown(evt);
			var keycode = evt.keyCode;
			switch (keycode) {
			case 35: 
				if (evt.altKey) {
					if (this.col + this.sw < this.sheet.maxCols - 1) {
						this.sw++;
						this.adjust("w");
					}
					evt.stop();
				}
				break;
			case 34: 
				if (evt.altKey) {
					if(this.row + this.sh <  this.sheet.maxRows - 1) {
						this.sh++;
						this.adjust("h");
					}
					evt.stop();
				}
				break;
			case 36: 
				if (evt.altKey) {
					if (this.sw > 0) {
						this.sw--;
						this.adjust("w");
					}
					evt.stop();
				}
				break;
			case 33: 
				if (evt.altKey) {
					if (this.sh > 0) {
						this.sh--;
						this.adjust("h");
					}
					evt.stop();
				}
				break;
			}	
		}
	},
	afterKeyDown_: function (evt, simulated) {
	},
	doKeyUp_: function (evt) {
		var sheet = this.sheet;
		if (sheet && sheet.state == zss.SSheetCtrl.EDITING) {
			var	sheet = this.sheet,
				formulabarEditor = sheet.formulabarEditor,
				value = sheet.inlineEditor.getValue(),
				keycode = evt.keyCode,
				info = sheet.editingFormulaInfo,
				n = this.comp,
				p = zk(n).getSelectionRange(),
				end = p[1];
			if (formulabarEditor) {
				formulabarEditor.setValue(value, end);
			}
			sheet._wgt.fire('onEditboxEditing', {token: '', sheetId: sheet.serverSheetId, row:this.row, col:this.col, clienttxt: value});
			
			if (!value) {
				sheet.editingFormulaInfo = null;
				return;
			}
			
			var tp = this._type;
			if (info) {
				info.type = tp;
				if (info.moveCell) {
					if (info.end != end) { 
						sheet.editingFormulaInfo = getEditingFormulaInfo(tp, n, p);
					} else {
						
					}
				} else {
					sheet.editingFormulaInfo = getEditingFormulaInfo(tp, n, p);
				}
			} else {
				sheet.editingFormulaInfo = getEditingFormulaInfo(tp, n, p);
			}
		}
	},
	
	disable: function (disabled) {
		this.comp.style.backgroundColor = disabled ? "#DDDDDD" : "#EFECFF";
		this.disabled = disabled;
	},
	
	setValue: function (v) {
		if (this.disabled) {
			return;
		}
		this.comp.value = v;
		this.autoAdjust(true);
	},
	_startEditing: function (noFocus) {
		var sheet = this.sheet;
		if (sheet) {
			this._editing = !noFocus;
			var formulabarEditor = sheet.formulabarEditor,
				n = this.comp,
				v = n.value;
			if (formulabarEditor) {
				formulabarEditor.setValue(v);
			}
			if ('=' == v.charAt(0)) {
				var p = v.length;
				sheet.editingFormulaInfo = getEditingFormulaInfo(this._type, n, [p, p]);	
			}
		}
	},
	
	edit: function (cellcmp, row, col, value, noFocus) {
		this.disable(false);
		this.row = row;
		this.col = col;
		this.sw = 0;
		this.sh = 0;
		var sheet = this.sheet,
			txtcmp = cellcmp.lastChild,
			editorcmp = this.comp,
			$edit = jq(editorcmp);

		editorcmp.value = value;
		var w = cellcmp.ctrl.overflowed ? (cellcmp.firstChild.offsetWidth + this.sheet.cellPad) : (cellcmp.offsetWidth);
		var h = cellcmp.offsetHeight;
		var $cell = cellcmp.ctrl;
		var scrollPanel = sheet.sp;
		
		var l = sheet.custColWidth.getStartPixel($cell.c) + sheet.leftWidth - (sheet.frozenCol >= 0 && col <= sheet.frozenCol ? 0 : scrollPanel.currentLeft);
		var t = sheet.custRowHeight.getStartPixel($cell.r) + sheet.topHeight - (sheet.frozenRow >= 0 && row <= sheet.frozenRow ? 0 : scrollPanel.currentTop);
		
		t -= 1;
		w -= 1;
		h -= 1;
		
		if ((zk.ie ) || zk.safari || zk.opera)
			
			w -= 2;

		this.editingWidth = w;
		this.editingHeight = h;

		
		$edit.css({'width': jq.px0(w), 'height': jq.px0(h), 'left': jq.px(l), 'top': jq.px(t), 'line-height': jq.px0(sheet.lineHeight)});
		if (!zk.ie || zk.ie >= 11)
			$edit.css('display', 'block');
		zcss.copyStyle(txtcmp, editorcmp, ["font-family","font-size","font-weight","font-style","color","text-decoration","text-align"],true);
		zcss.copyStyle(cellcmp, editorcmp, ["background-color"], true);

		this._startEditing(noFocus);
   			
		
		fun = function () {
			var pos = editorcmp.value.length;
			if (editorcmp.setSelectionRange) {
				editorcmp.setSelectionRange(pos,pos);
			} else if (editorcmp.createTextRange) {
				var range = editorcmp.createTextRange();
				range.move('character', pos);
				range.select();
			}
		};

		if (!zk.safari && (!zk.ie )) fun();
		setTimeout(function(){
			
			if (zk.ie ) {
				$edit.show();
			}
			if (!noFocus) {
				$edit.focus();
				
				if (zk.safari || (zk.ie )) fun();
			}
		}, 25);	
		this.autoAdjust(true);
	},
	cancel: function () {
		this._editing = false;
		this.disable(true);
		jq(this.comp).val('').css('display', 'none');
		this.row = this.col = -1;
	},
	stop: function () {
		if (this.sheet)
			this.sheet.editingFormulaInfo = null;
		this._editing = false;
		this.disable(true);
		var editorcmp = this.comp,
			str = editorcmp.value;
		jq(editorcmp).val('').css('display', 'none');
		this.row = this.col = -1;
		return str;
	},
	getValue: function () {
		return this.comp.value;
	},
	newLine: function () {
		newLine(this.comp);
		this.autoAdjust();
	},
	adjust: function (type) {
		var editorcmp = this.comp;

		if (type == "w") {
			var custColWidth = this.sheet.custColWidth,
				w = custColWidth.getStartPixel(this.col + this.sw + 1) - custColWidth.getStartPixel(this.col);
			if ((zk.ie && zk.ie < 11) || zk.safari || zk.opera)
				w -= 2;
			jq(editorcmp).css('width', jq.px0(w));
		} else if (type=="h") {
			var custRowHeight = this.sheet.custRowHeight,
				h = custRowHeight.getStartPixel(this.row + this.sh + 1) - custRowHeight.getStartPixel(this.row);
			jq(editorcmp).css('height', jq.px0(h));
		}
	},
	autoAdjust: function (forceadj) {
		var local = this;
		setTimeout(function() {
			var editorcmp = local.comp,
				ch = editorcmp.clientHeight,
				cw = editorcmp.clientWidth,
				sw = editorcmp.scrollWidth,
				sh = editorcmp.scrollHeight,
				hsb = zkS._hasScrollBar(editorcmp),
				vsb = zkS._hasScrollBar(editorcmp, true);
			
			if (sh > ch + 3) {
				if (hsb && !vsb)
					jq(editorcmp).css('height', jq.px0(sh + zss.Spreadsheet.scrollWidth));
				else
					jq(editorcmp).css('height', jq.px0(sh));
			}
			if (sh > ch + 3 || forceadj) {
				var custColWidth = local.sheet.custColWidth,
					custRowHeight = local.sheet.custRowHeight;
				local.sw = custColWidth.getCellIndex(custColWidth.getStartPixel(local.col) + sw)[0] - local.col;
				local.sh = custRowHeight.getCellIndex(custRowHeight.getStartPixel(local.row) + sh)[0] - local.row;
			}			
		}, 0);
	},
	redrawHTML_: function () {
		return '<textarea id="' + this.uuid + '" class="zsedit" zs.t="SEditbox"></textarea>';
	}
});
})();